/**
 * Sample controller
 * @class Controllers.main
 */

/**
 * Slides the detailview out of the picture
 * @param {Object} _evt The javascript object passed by the event
 */
function onListItemTouchMove(_evt){ 
	
	Ti.API.info(JSON.stringify(_evt));
	
	var left = Math.round(_evt.source.convertPointToView({x:_evt.x,y:_evt.y},_evt.source.parent).x);
	_evt.source.left = left > 0 ? left : 0;
	
	var hiddenLbl = _evt.source.parent.children[0].children[0]; 
	if((_evt.source.left > 100) && hiddenLbl.text === "Slide >"){
		hiddenLbl.animate({
			opacity: 0.0,
			duration: 125
		}, function(){
			hiddenLbl.text = "Release +";
				hiddenLbl.animate({
				opacity: 1.0,
				duration: 125
			});
		}) ;
	}
	else if((_evt.source.left < 100) && hiddenLbl.text !== "Slide >"){
		hiddenLbl.animate({
			opacity: 0.0,
			duration: 125
		}, function(){
			hiddenLbl.text = "Slide >";
				hiddenLbl.animate({
				opacity: 1.0,
				duration: 125
			});
		}) ;
	}
	hiddenLbl.left = left-100;
	
	_evt.cancelBubble=true;
}

function onListItemTouchEnd(_evt){  
	
	if(_evt.source.left > 100){	
		
		var hiddenLbl = _evt.source.parent.children[0].children[0];
		hiddenLbl.animate({
			opacity: 0.0,
			duration: 125
		}, function(){
			hiddenLbl.applyProperties({
				text: "You have added it!",
				width: Ti.UI.FILL,
				left: 0,
				textAlign: "center"
			});
			hiddenLbl.animate({
				opacity: 1.0,
				duration: 125
			});
		}) ; 
		
		
		_evt.source.animate({ 
			left: 200,
			duration: 250 
		}, function(){
			setTimeout(function(){
				_evt.source.parent.parent.animate({
					opacity: 0.0,
					duration: 250
				}, function(){
					var section = $.wrapper.sections[_evt.sectionIndex];
					section.deleteItemsAt(_evt.itemIndex, 1, false);
				});
			}, 250);
		});
		
	} else {
		_evt.source.animate({ 
			left: 0,
			duration: 250 
		});
	};
}

/**
 * Slides the top layer of the ListView over to the right and fades it out before
 * removing it
 * @param {Object} _evt - object passed in by event handler
 */
function onButtonClick(_evt){
	if(_evt.source.parent){	
		
		var hiddenLbl = _evt.source.parent.parent.children[0].children[0]; 
		hiddenLbl.applyProperties({
			text: "You have added it!",
			textAlign: "center"
		});
			
		_evt.source.parent.animate({ 
			left: 200,
			duration: 250 
		}, function(){
			_evt.source.parent.parent.parent.animate({
				opacity: 0.0,
				duration: 500
			},function(){
				var section = $.wrapper.sections[_evt.sectionIndex];
				section.deleteItemsAt(_evt.itemIndex, 1, false);
			});
			
		});
	} 
};

/**
 * Public method to handle orientation if this controller
 * is opened via {@link core#openScreen} or if
 * {@link core#bindOrientationEvents} is applied to this controller
 * @param {Object} _event
 */
$.handleOrientation = function(_event) {
	Ti.API.debug(_event.orientation);
};